// (C) Timofey S. Chistyakov, 2005

{$apptype console}
{$r+}

uses
  Math, Types, SysUtils, Classes;

const
  INF = High(shortint);
  
var
  a, b: integer;
  ss: TStringList;
  m: array of TShortIntDynArray;

function Idx(ALine, ACol: integer): integer;
var
  i: integer;
begin
  Result := 0;
  for i := 0 to ALine - 1 do
    Inc(Result, Length(ss[i]));
  Inc(Result, ACol - 1);
end;


procedure Jump(ALine, ACol: integer);
var
  c: integer;
  si: integer;
begin
  si := Idx(ALine, ACol);
  
  if ACol > 1 then
    m[si, Idx(ALine, ACol - 1)] := 1;
  if ACol < Length(ss[ALine]) then
    m[si, Idx(ALine, ACol + 1)] := 1;
  if ALine > 0 then
    m[si, Idx(ALine - 1, Min(ACol, Length(ss[ALine - 1])))] := 1;
  if ALine < ss.Count - 1 then
    m[si, Idx(ALine + 1, Min(ACol, Length(ss[ALine + 1])))] := 1;
  if ACol > 1 then
    m[si, Idx(ALine, 1)] := 1;
  if ACol < Length(ss[ALine]) then
    m[si, Idx(ALine, Length(ss[ALine]))] := 1;

  // ^LEFT
  c := ACol;
  if (ss[ALine][c] <> ' ') and (c > 1) and (ss[ALine][c - 1] <> ' ') then begin
    while (c > 1) and (ss[ALine][c] <> ' ') do
      Dec(c);
    if (c > 1) then
      Inc(c);
    m[si, Idx(ALine, c)] := Min(2, m[si, Idx(ALine, c)]);
  end
  else begin
    if (ss[ALine][c] <> ' ') and (c > 1) then
      Dec(c);
    while (c > 1) and (ss[ALine][c] = ' ') do
      Dec(c);
  end;
  while (c > 1) and (ss[ALine][c] <> ' ') do
    Dec(c);
  if (c > 1) then
    Inc(c);
  m[si, Idx(ALine, c)] := Min(2, m[si, Idx(ALine, c)]);


  // ^RIGHT
  c := ACol;
  if (ss[ALine][c] <> ' ') then 
    while (c < Length(ss[ALine])) and (ss[ALine][c] <> ' ') do
      Inc(c);
  while (c < Length(ss[ALine])) and (ss[ALine][c] = ' ') do
    Inc(c);
  m[si, Idx(ALine, c)] := Min(2, m[si, Idx(ALine, c)]);
end;


var
  fo: textfile;
  s: string;
  i, j: integer;
  cc: integer;
  reached: TBooleanDynArray;
  dist: TIntegerDynArray;
  src, minI: integer;
begin
  AssignFile(fo, 'output.txt');
  Rewrite(fo);

  ss := TStringList.Create;
  ss.LoadFromFile('input.txt');
  s := Trim(ss[0]);
  ss.Delete(0);

  a := StrToInt(Copy(s, 1, Pos(' ', s) - 1));
  Delete(s, 1, Pos(' ', s));
  s := Trim(s);
  b := StrToInt(s);

  for i := 0 to ss.Count - 1 do begin
    Assert(ss[i] <> '');
    Assert(ss[i][1] <> ' ');
    Assert(ss[i][Length(ss[i])] <> ' ');
    for j := 1 to Length(ss[i]) do
      Assert((ss[i][j] = ' ') or (ss[i][j] > #32));
    ss[i] := Trim(ss[i]);
  end;

  cc := Idx(ss.Count - 1, Length(ss[ss.Count - 1])) + 1;
  Assert(cc < 2000);

  SetLength(m, cc, cc);
  for i := 0 to High(m) do
    for j := 0 to High(m) do
      if i <> j then
        m[i, j] := INF
      else
        m[i, j] := 0;

  for i := 0 to ss.Count - 1 do
    for j := 1 to Length(ss[i]) do
      Jump(i, j);

  SetLength(reached, cc);
  FillChar(reached[0], cc, false);
  src := Idx(a - 1, b);
  reached[src] := true;
  SetLength(dist, cc);
  for i := 0 to High(dist) do
    dist[i] := m[src, i];

  while true do begin
    minI := -1;
    for i := 0 to cc - 1 do
      if not reached[i] then
        if (dist[i] <> INF) and ((minI = -1) or (dist[i] < dist[minI])) then
          minI := i;

    if minI = -1 then
      Break;

    reached[minI] := true;
    for i := 0 to cc - 1 do
      if (m[minI, i] <> INF) then
        if (dist[i] = INF) then
          dist[i] := dist[minI] + m[minI, i]
        else
          dist[i] := Min(dist[i], dist[minI] + m[minI, i]);
  end;
  Write(fo, MaxIntValue(dist));
  CloseFile(fo);
end.
